fix(uti): Fixing broken code part II
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2021 Cisco and/or its affiliates.
2 # Copyright (c) 2021 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     parse_env_variables || die "Parse of environment variables failed!"
83
84     # Replace all variables in template with those in environment.
85     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
86         die "Topology file create failed!"
87     }
88
89     WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
90     mv topo.yml "${WORKING_TOPOLOGY}" || {
91         die "Topology move failed!"
92     }
93     cat ${WORKING_TOPOLOGY} | grep -v password || {
94         die "Topology read failed!"
95     }
96 }
97
98
99 function activate_virtualenv () {
100
101     # Update virtualenv pip package, delete and create virtualenv directory,
102     # activate the virtualenv, install requirements, set PYTHONPATH.
103
104     # Arguments:
105     # - ${1} - Path to existing directory for creating virtualenv in.
106     #          If missing or empty, ${CSIT_DIR} is used.
107     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
108     # Variables read:
109     # - CSIT_DIR - Path to existing root of local CSIT git repository.
110     # Variables exported:
111     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
112     # Functions called:
113     # - die - Print to stderr and exit.
114
115     set -exuo pipefail
116
117     root_path="${1-$CSIT_DIR}"
118     env_dir="${root_path}/env"
119     req_path=${2-$CSIT_DIR/requirements.txt}
120     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
121     pip3 install virtualenv==20.0.20 || {
122         die "Virtualenv package install failed."
123     }
124     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
125         die "Virtualenv creation for $(which python3) failed."
126     }
127     set +u
128     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
129     set -u
130     pip3 install -r "${req_path}" || {
131         die "Requirements installation failed."
132     }
133     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
134     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
135 }
136
137
138 function archive_tests () {
139
140     # Create .tar.xz of generated/tests for archiving.
141     # To be run after generate_tests, kept separate to offer more flexibility.
142
143     # Directory read:
144     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
145     # File rewriten:
146     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
147
148     set -exuo pipefail
149
150     filename="generated_robot_files.tar.xz"
151     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/${filename}" || {
152         die "Error creating archive of generated tests."
153     }
154 }
155
156
157 function check_download_dir () {
158
159     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
160     #
161     # Variables read:
162     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
163     # Directories read:
164     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
165     # Functions called:
166     # - die - Print to stderr and exit.
167
168     set -exuo pipefail
169
170     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
171         die "No artifacts downloaded!"
172     fi
173 }
174
175
176 function check_prerequisites () {
177
178     # Fail if prerequisites are not met.
179     #
180     # Functions called:
181     # - installed - Check if application is installed/present in system.
182     # - die - Print to stderr and exit.
183
184     set -exuo pipefail
185
186     if ! installed sshpass; then
187         die "Please install sshpass before continue!"
188     fi
189 }
190
191
192 function common_dirs () {
193
194     # Set global variables, create some directories (without touching content).
195
196     # Variables set:
197     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
198     # - CSIT_DIR - Path to existing root of local CSIT git repository.
199     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
200     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
201     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
202     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
203     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
204     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
205     #   The name is chosen to match what ci-management expects.
206     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
207     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
208     # Directories created if not present:
209     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
210     # Functions called:
211     # - die - Print to stderr and exit.
212
213     set -exuo pipefail
214
215     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
216         die "Some error during locating of this source file."
217     }
218     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
219         die "Some error during dirname call."
220     }
221     # Current working directory could be in a different repo, e.g. VPP.
222     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
223     relative_csit_dir=$(git rev-parse --show-toplevel) || {
224         die "Git rev-parse failed."
225     }
226     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
227     popd || die "Popd failed."
228     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
229         die "Readlink failed."
230     }
231     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
232         die "Readlink failed."
233     }
234     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
235         die "Readlink failed."
236     }
237     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
238         die "Readlink failed."
239     }
240     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
241         die "Readlink failed."
242     }
243     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
244         die "Readlink failed."
245     }
246
247     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
251     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
255     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
256         die "Readlink failed."
257     }
258     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
259 }
260
261
262 function compose_pybot_arguments () {
263
264     # Variables read:
265     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
266     # - DUT - CSIT test/ subdirectory, set while processing tags.
267     # - TAGS - Array variable holding selected tag boolean expressions.
268     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
269     # - TEST_CODE - The test selection string from environment or argument.
270     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
271     # Variables set:
272     # - PYBOT_ARGS - String holding part of all arguments for pybot.
273     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
274
275     set -exuo pipefail
276
277     # No explicit check needed with "set -u".
278     PYBOT_ARGS=("--loglevel" "TRACE")
279     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
280
281     case "${TEST_CODE}" in
282         *"device"*)
283             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
284             ;;
285         *"perf"*)
286             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
287             ;;
288         *)
289             die "Unknown specification: ${TEST_CODE}"
290     esac
291
292     EXPANDED_TAGS=()
293     for tag in "${TAGS[@]}"; do
294         if [[ ${tag} == "!"* ]]; then
295             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
296         else
297             if [[ ${SELECTION_MODE} == "--test" ]]; then
298                 EXPANDED_TAGS+=("--test" "${tag}")
299             else
300                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
301             fi
302         fi
303     done
304
305     if [[ ${SELECTION_MODE} == "--test" ]]; then
306         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
307     fi
308 }
309
310
311 function deactivate_docker_topology () {
312
313     # Deactivate virtual vpp-device topology by removing containers.
314     #
315     # Variables read:
316     # - NODENESS - Node multiplicity of desired testbed.
317     # - FLAVOR - Node flavor string, usually describing the processor.
318
319     set -exuo pipefail
320
321     case_text="${NODENESS}_${FLAVOR}"
322     case "${case_text}" in
323         "1n_skx" | "1n_tx2")
324             ssh="ssh root@172.17.0.1 -p 6022"
325             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
326             # The "declare -f" output is long and boring.
327             set +x
328             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
329                 die "Topology cleanup via shim-dcr failed!"
330             }
331             set -x
332             ;;
333         "1n_vbox")
334             enter_mutex || die
335             clean_environment || {
336                 die "Topology cleanup locally failed!"
337             }
338             exit_mutex || die
339             ;;
340         *)
341             die "Unknown specification: ${case_text}!"
342     esac
343 }
344
345
346 function die () {
347
348     # Print the message to standard error end exit with error code specified
349     # by the second argument.
350     #
351     # Hardcoded values:
352     # - The default error message.
353     # Arguments:
354     # - ${1} - The whole error message, be sure to quote. Optional
355     # - ${2} - the code to exit with, default: 1.
356
357     set -x
358     set +eu
359     warn "${1:-Unspecified run-time error occurred!}"
360     exit "${2:-1}"
361 }
362
363
364 function die_on_pybot_error () {
365
366     # Source this fragment if you want to abort on any failed test case.
367     #
368     # Variables read:
369     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
370     # Functions called:
371     # - die - Print to stderr and exit.
372
373     set -exuo pipefail
374
375     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
376         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
377     fi
378 }
379
380
381 function generate_tests () {
382
383     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
384     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
385     # The generation is done by executing any *.py executable
386     # within any subdirectory after copying.
387
388     # This is a separate function, because this code is called
389     # both by autogen checker and entries calling run_pybot.
390
391     # Directories read:
392     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
393     # Directories replaced:
394     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
395
396     set -exuo pipefail
397
398     rm -rf "${GENERATED_DIR}/tests" || die
399     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
400     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
401     cmd_line+=("-executable" "-name" "*.py")
402     # We sort the directories, so log output can be compared between runs.
403     file_list=$("${cmd_line[@]}" | sort) || die
404
405     for gen in ${file_list}; do
406         directory="$(dirname "${gen}")" || die
407         filename="$(basename "${gen}")" || die
408         pushd "${directory}" || die
409         ./"${filename}" || die
410         popd || die
411     done
412 }
413
414
415 function get_test_code () {
416
417     # Arguments:
418     # - ${1} - Optional, argument of entry script (or empty as unset).
419     #   Test code value to override job name from environment.
420     # Variables read:
421     # - JOB_NAME - String affecting test selection, default if not argument.
422     # Variables set:
423     # - TEST_CODE - The test selection string from environment or argument.
424     # - NODENESS - Node multiplicity of desired testbed.
425     # - FLAVOR - Node flavor string, usually describing the processor.
426
427     set -exuo pipefail
428
429     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
430     if [[ -z "${TEST_CODE}" ]]; then
431         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
432     fi
433
434     case "${TEST_CODE}" in
435         *"1n-vbox"*)
436             NODENESS="1n"
437             FLAVOR="vbox"
438             ;;
439         *"1n-skx"*)
440             NODENESS="1n"
441             FLAVOR="skx"
442             ;;
443        *"1n-tx2"*)
444             NODENESS="1n"
445             FLAVOR="tx2"
446             ;;
447         *"2n-aws"*)
448             NODENESS="2n"
449             FLAVOR="aws"
450             ;;
451         *"3n-aws"*)
452             NODENESS="3n"
453             FLAVOR="aws"
454             ;;
455         *"2n-skx"*)
456             NODENESS="2n"
457             FLAVOR="skx"
458             ;;
459         *"2n-zn2"*)
460             NODENESS="2n"
461             FLAVOR="zn2"
462             ;;
463         *"3n-skx"*)
464             NODENESS="3n"
465             FLAVOR="skx"
466             ;;
467         *"2n-clx"*)
468             NODENESS="2n"
469             FLAVOR="clx"
470             ;;
471         *"2n-dnv"*)
472             NODENESS="2n"
473             FLAVOR="dnv"
474             ;;
475         *"3n-dnv"*)
476             NODENESS="3n"
477             FLAVOR="dnv"
478             ;;
479         *"2n-tx2"*)
480             NODENESS="2n"
481             FLAVOR="tx2"
482             ;;
483         *"3n-tsh"*)
484             NODENESS="3n"
485             FLAVOR="tsh"
486             ;;
487     esac
488 }
489
490
491 function get_test_tag_string () {
492
493     # Variables read:
494     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
495     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
496     # - TEST_CODE - The test selection string from environment or argument.
497     # Variables set:
498     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
499     #   May be empty, or even not set on event types not adding comment.
500
501     # TODO: ci-management scripts no longer need to perform this.
502
503     set -exuo pipefail
504
505     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
506         case "${TEST_CODE}" in
507             *"device"*)
508                 trigger="devicetest"
509                 ;;
510             *"perf"*)
511                 trigger="perftest"
512                 ;;
513             *)
514                 die "Unknown specification: ${TEST_CODE}"
515         esac
516         # Ignore lines not containing the trigger word.
517         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
518         # The vpp-csit triggers trail stuff we are not interested in.
519         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
520         # (except relying on \s whitespace, \S non-whitespace and . both).
521         # The last string is concatenated, only the middle part is expanded.
522         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
523         # On parsing error, TEST_TAG_STRING probably stays empty.
524         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
525         if [[ -z "${TEST_TAG_STRING-}" ]]; then
526             # Probably we got a base64 encoded comment.
527             comment="${GERRIT_EVENT_COMMENT_TEXT}"
528             comment=$(base64 --decode <<< "${comment}" || true)
529             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
530             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
531         fi
532         if [[ -n "${TEST_TAG_STRING-}" ]]; then
533             test_tag_array=(${TEST_TAG_STRING})
534             if [[ "${test_tag_array[0]}" == "icl" ]]; then
535                 export GRAPH_NODE_VARIANT="icl"
536                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
537             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
538                 export GRAPH_NODE_VARIANT="skx"
539                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
540             fi
541         fi
542     fi
543 }
544
545
546 function installed () {
547
548     # Check if the given utility is installed. Fail if not installed.
549     #
550     # Duplicate of common.sh function, as this file is also used standalone.
551     #
552     # Arguments:
553     # - ${1} - Utility to check.
554     # Returns:
555     # - 0 - If command is installed.
556     # - 1 - If command is not installed.
557
558     set -exuo pipefail
559
560     command -v "${1}"
561 }
562
563
564 function move_archives () {
565
566     # Move archive directory to top of workspace, if not already there.
567     #
568     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
569     # but in some jobs CSIT_DIR is not same as WORKSPACE
570     # (e.g. under VPP_DIR). To simplify ci-management settings,
571     # we want to move the data to the top. We do not want simple copy,
572     # as ci-management is eager with recursive search.
573     #
574     # As some scripts may call this function multiple times,
575     # the actual implementation use copying and deletion,
576     # so the workspace gets "union" of contents (except overwrites on conflict).
577     # The consequence is empty ARCHIVE_DIR remaining after this call.
578     #
579     # As the source directory is emptied,
580     # the check for dirs being different is essential.
581     #
582     # Variables read:
583     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
584     #   Can be unset, then it speeds up manual testing.
585     # - ARCHIVE_DIR - Path to directory with content to be moved.
586     # Directories updated:
587     # - ${WORKSPACE}/archives/ - Created if does not exist.
588     #   Content of ${ARCHIVE_DIR}/ is moved.
589     # Functions called:
590     # - die - Print to stderr and exit.
591
592     set -exuo pipefail
593
594     if [[ -n "${WORKSPACE-}" ]]; then
595         target=$(readlink -f "${WORKSPACE}/archives")
596         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
597             mkdir -p "${target}" || die "Archives dir create failed."
598             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
599             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
600         fi
601     fi
602 }
603
604
605 function post_process_robot_outputs () {
606
607     # Generate INFO level output_info.xml by rebot.
608     # Archive UTI raw json outputs.
609     #
610     # Variables read:
611     # - ARCHIVE_DIR - Path to post-processed files.
612
613     set -exuo pipefail
614
615     # Compress raw json outputs, as they will never be post-processed.
616     pushd "${ARCHIVE_DIR}" || die
617     if [ -d "tests" ]; then
618         # Use deterministic order.
619         options+=("--sort=name")
620         # We are keeping info outputs where they are.
621         # Assuming we want to move anything but info files (and dirs).
622         options+=("--exclude=*.info.json")
623         tar czvf "tests_output_raw.tar.gz" "${options[@]}" "tests" || true
624         # Tar can remove when archiving, but chokes (not deterministically)
625         # on attempting to remove dirs (not empty as info files are there).
626         # So we need to delete the raw files manually.
627         find "tests" -type f -name "*.raw.json" -delete || true
628     fi
629     popd || die
630
631     # Generate INFO level output_info.xml for post-processing.
632     all_options=("--loglevel" "INFO")
633     all_options+=("--log" "none")
634     all_options+=("--report" "none")
635     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
636     all_options+=("${ARCHIVE_DIR}/output.xml")
637     rebot "${all_options[@]}" || true
638 }
639
640
641 function prepare_topology () {
642
643     # Prepare virtual testbed topology if needed based on flavor.
644
645     # Variables read:
646     # - TEST_CODE - String affecting test selection, usually jenkins job name.
647     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
648     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
649     # Functions called:
650     # - die - Print to stderr and exit.
651     # - terraform_init - Terraform init topology.
652     # - terraform_apply - Terraform apply topology.
653
654     set -exuo pipefail
655
656     case_text="${NODENESS}_${FLAVOR}"
657     case "${case_text}" in
658         "2n_aws")
659             export TF_VAR_testbed_name="${TEST_CODE}"
660             terraform_init || die "Failed to call terraform init."
661             terraform_apply || die "Failed to call terraform apply."
662             ;;
663         "3n_aws")
664             export TF_VAR_testbed_name="${TEST_CODE}"
665             terraform_init || die "Failed to call terraform init."
666             terraform_apply || die "Failed to call terraform apply."
667             ;;
668     esac
669 }
670
671
672 function reserve_and_cleanup_testbed () {
673
674     # Reserve physical testbed, perform cleanup, register trap to unreserve.
675     # When cleanup fails, remove from topologies and keep retrying
676     # until all topologies are removed.
677     #
678     # Variables read:
679     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
680     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
681     # - BUILD_TAG - Any string suitable as filename, identifying
682     #   test run executing this function. May be unset.
683     # Variables set:
684     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
685     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
686     # Functions called:
687     # - die - Print to stderr and exit.
688     # - ansible_playbook - Perform an action using ansible, see ansible.sh
689     # Traps registered:
690     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
691
692     set -exuo pipefail
693
694     while true; do
695         for topo in "${TOPOLOGIES[@]}"; do
696             set +e
697             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
698             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
699             python3 "${scrpt}" "${opts[@]}"
700             result="$?"
701             set -e
702             if [[ "${result}" == "0" ]]; then
703                 # Trap unreservation before cleanup check,
704                 # so multiple jobs showing failed cleanup improve chances
705                 # of humans to notice and fix.
706                 WORKING_TOPOLOGY="${topo}"
707                 echo "Reserved: ${WORKING_TOPOLOGY}"
708                 trap "untrap_and_unreserve_testbed" EXIT || {
709                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
710                     untrap_and_unreserve_testbed "${message}" || {
711                         die "Teardown should have died, not failed."
712                     }
713                     die "Trap attempt failed, unreserve succeeded. Aborting."
714                 }
715                 # Cleanup + calibration checks
716                 set +e
717                 ansible_playbook "cleanup, calibration"
718                 result="$?"
719                 set -e
720                 if [[ "${result}" == "0" ]]; then
721                     break
722                 fi
723                 warn "Testbed cleanup failed: ${topo}"
724                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
725             fi
726             # Else testbed is accessible but currently reserved, moving on.
727         done
728
729         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
730             # Exit the infinite while loop if we made a reservation.
731             warn "Reservation and cleanup successful."
732             break
733         fi
734
735         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
736             die "Run out of operational testbeds!"
737         fi
738
739         # Wait ~3minutes before next try.
740         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
741             die "Sleep time calculation failed."
742         }
743         echo "Sleeping ${sleep_time}"
744         sleep "${sleep_time}" || die "Sleep failed."
745     done
746 }
747
748
749 function run_pybot () {
750
751     # Run pybot with options based on input variables.
752     # Generate INFO level output_info.xml by rebot.
753     # Archive UTI raw json outputs.
754     #
755     # Variables read:
756     # - CSIT_DIR - Path to existing root of local CSIT git repository.
757     # - ARCHIVE_DIR - Path to store robot result files in.
758     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
759     # - GENERATED_DIR - Tests are assumed to be generated under there.
760     # Variables set:
761     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
762     # Functions called:
763     # - die - Print to stderr and exit.
764
765     set -exuo pipefail
766
767     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
768     all_options+=("--noncritical" "EXPECTED_FAILING")
769     all_options+=("${EXPANDED_TAGS[@]}")
770
771     pushd "${CSIT_DIR}" || die "Change directory operation failed."
772     set +e
773     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
774     PYBOT_EXIT_STATUS="$?"
775     set -e
776
777     post_process_robot_outputs || die
778
779     popd || die "Change directory operation failed."
780 }
781
782
783 function select_arch_os () {
784
785     # Set variables affected by local CPU architecture and operating system.
786     #
787     # Variables set:
788     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
789     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
790     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
791
792     set -exuo pipefail
793
794     source /etc/os-release || die "Get OS release failed."
795
796     case "${ID}" in
797         "ubuntu"*)
798             case "${VERSION}" in
799                 *"LTS (Focal Fossa)"*)
800                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
801                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_FOCAL"
802                     PKG_SUFFIX="deb"
803                     ;;
804                 *)
805                     die "Unsupported Ubuntu version!"
806                     ;;
807             esac
808             ;;
809         *)
810             die "Unsupported distro or OS!"
811             ;;
812     esac
813
814     arch=$(uname -m) || {
815         die "Get CPU architecture failed."
816     }
817
818     case "${arch}" in
819         "aarch64")
820             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
821             ;;
822         *)
823             ;;
824     esac
825 }
826
827
828 function select_tags () {
829
830     # Variables read:
831     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
832     # - TEST_CODE - String affecting test selection, usually jenkins job name.
833     # - DUT - CSIT test/ subdirectory, set while processing tags.
834     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
835     #   Can be unset.
836     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
837     # - BASH_FUNCTION_DIR - Directory with input files to process.
838     # Variables set:
839     # - TAGS - Array of processed tag boolean expressions.
840     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
841
842     set -exuo pipefail
843
844     # NIC SELECTION
845     start_pattern='^  TG:'
846     end_pattern='^ \? \?[A-Za-z0-9]\+:'
847     # Remove the TG section from topology file
848     sed_command="/${start_pattern}/,/${end_pattern}/d"
849     # All topologies DUT NICs
850     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
851                 | grep -hoP "model: \K.*" | sort -u)
852     # Selected topology DUT NICs
853     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
854                | grep -hoP "model: \K.*" | sort -u)
855     # All topologies DUT NICs - Selected topology DUT NICs
856     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
857         die "Computation of excluded NICs failed."
858     }
859
860     # Select default NIC tag.
861     case "${TEST_CODE}" in
862         *"3n-dnv"* | *"2n-dnv"*)
863             default_nic="nic_intel-x553"
864             ;;
865         *"3n-tsh"*)
866             default_nic="nic_intel-x520-da2"
867             ;;
868         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
869             default_nic="nic_intel-xxv710"
870             ;;
871         *"2n-tx2"* | *"mrr-daily-master")
872             default_nic="nic_intel-xl710"
873             ;;
874         *"2n-aws"* | *"3n-aws"*)
875             default_nic="nic_amazon-nitro-50g"
876             ;;
877         *)
878             default_nic="nic_intel-x710"
879             ;;
880     esac
881
882     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
883     awk_nics_sub_cmd=""
884     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
885     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
886     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
887     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
888     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
889     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
890     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
891     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
892     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
893     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
894     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
895     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
896     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
897     awk_nics_sub_cmd+='else drv="";'
898     awk_nics_sub_cmd+='if ($1 =="-") cores="";'
899     awk_nics_sub_cmd+='else cores=$1;'
900     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
901
902     # Tag file directory shorthand.
903     tfd="${JOB_SPECS_DIR}"
904     case "${TEST_CODE}" in
905         # Select specific performance tests based on jenkins job type variable.
906         *"device"* )
907             readarray -t test_tag_array <<< $(grep -v "#" \
908                 ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
909                 awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
910             SELECTION_MODE="--test"
911             ;;
912         *"ndrpdr-weekly"* )
913             readarray -t test_tag_array <<< $(grep -v "#" \
914                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
915                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
916             SELECTION_MODE="--test"
917             ;;
918         *"mrr-daily"* )
919             readarray -t test_tag_array <<< $(grep -v "#" \
920                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
921                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
922             SELECTION_MODE="--test"
923             ;;
924         *"mrr-weekly"* )
925             readarray -t test_tag_array <<< $(grep -v "#" \
926                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
927                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
928             SELECTION_MODE="--test"
929             ;;
930         *"report-iterative"* )
931             test_sets=(${TEST_TAG_STRING//:/ })
932             # Run only one test set per run
933             report_file=${test_sets[0]}.md
934             readarray -t test_tag_array <<< $(grep -v "#" \
935                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
936                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
937             SELECTION_MODE="--test"
938             ;;
939         *"report-coverage"* )
940             test_sets=(${TEST_TAG_STRING//:/ })
941             # Run only one test set per run
942             report_file=${test_sets[0]}.md
943             readarray -t test_tag_array <<< $(grep -v "#" \
944                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
945                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
946             SELECTION_MODE="--test"
947             ;;
948         * )
949             if [[ -z "${TEST_TAG_STRING-}" ]]; then
950                 # If nothing is specified, we will run pre-selected tests by
951                 # following tags.
952                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
953                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
954                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
955                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
956                                 "!drv_af_xdp" "!drv_avf")
957             else
958                 # If trigger contains tags, split them into array.
959                 test_tag_array=(${TEST_TAG_STRING//:/ })
960             fi
961             SELECTION_MODE="--include"
962             ;;
963     esac
964
965     # Blacklisting certain tags per topology.
966     #
967     # Reasons for blacklisting:
968     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
969     case "${TEST_CODE}" in
970         *"1n-vbox"*)
971             test_tag_array+=("!avf")
972             test_tag_array+=("!vhost")
973             test_tag_array+=("!flow")
974             ;;
975         *"1n_tx2"*)
976             test_tag_array+=("!flow")
977             ;;
978         *"2n-skx"*)
979             test_tag_array+=("!ipsechw")
980             ;;
981         *"3n-skx"*)
982             test_tag_array+=("!ipsechw")
983             # Not enough nic_intel-xxv710 to support double link tests.
984             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
985             ;;
986         *"2n-clx"*)
987             test_tag_array+=("!ipsechw")
988             ;;
989         *"2n-zn2"*)
990             test_tag_array+=("!ipsechw")
991             ;;
992         *"2n-dnv"*)
993             test_tag_array+=("!memif")
994             test_tag_array+=("!srv6_proxy")
995             test_tag_array+=("!vhost")
996             test_tag_array+=("!vts")
997             test_tag_array+=("!drv_avf")
998             ;;
999         *"2n-tx2"*)
1000             test_tag_array+=("!ipsechw")
1001             ;;
1002         *"3n-dnv"*)
1003             test_tag_array+=("!memif")
1004             test_tag_array+=("!srv6_proxy")
1005             test_tag_array+=("!vhost")
1006             test_tag_array+=("!vts")
1007             test_tag_array+=("!drv_avf")
1008             ;;
1009         *"3n-tsh"*)
1010             # 3n-tsh only has x520 NICs which don't work with AVF
1011             test_tag_array+=("!drv_avf")
1012             test_tag_array+=("!ipsechw")
1013             ;;
1014         *"2n-aws"* | *"3n-aws"*)
1015             test_tag_array+=("!ipsechw")
1016             ;;
1017     esac
1018
1019     # We will add excluded NICs.
1020     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
1021
1022     TAGS=()
1023     prefix=""
1024
1025     set +x
1026     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1027         if [[ "${TEST_CODE}" != *"device"* ]]; then
1028             # Automatic prefixing for VPP perf jobs to limit the NIC used and
1029             # traffic evaluation to MRR.
1030             if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
1031                 prefix="${prefix}mrrAND"
1032             else
1033                 prefix="${prefix}mrrAND${default_nic}AND"
1034             fi
1035         fi
1036     fi
1037     for tag in "${test_tag_array[@]}"; do
1038         if [[ "${tag}" == "!"* ]]; then
1039             # Exclude tags are not prefixed.
1040             TAGS+=("${tag}")
1041         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
1042             # Badly formed tag expressions can trigger way too much tests.
1043             set -x
1044             warn "The following tag expression hints at bad trigger: ${tag}"
1045             warn "Possible cause: Multiple triggers in a single comment."
1046             die "Aborting to avoid triggering too many tests."
1047         elif [[ "${tag}" == *"OR"* ]]; then
1048             # If OR had higher precedence than AND, it would be useful here.
1049             # Some people think it does, thus triggering way too much tests.
1050             set -x
1051             warn "The following tag expression hints at bad trigger: ${tag}"
1052             warn "Operator OR has lower precedence than AND. Use space instead."
1053             die "Aborting to avoid triggering too many tests."
1054         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
1055             # Empty and comment lines are skipped.
1056             # Other lines are normal tags, they are to be prefixed.
1057             TAGS+=("${prefix}${tag}")
1058         fi
1059     done
1060     set -x
1061 }
1062
1063
1064 function select_topology () {
1065
1066     # Variables read:
1067     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1068     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1069     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1070     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1071     # Variables set:
1072     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1073     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1074     # Functions called:
1075     # - die - Print to stderr and exit.
1076
1077     set -exuo pipefail
1078
1079     case_text="${NODENESS}_${FLAVOR}"
1080     case "${case_text}" in
1081         "1n_vbox")
1082             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1083             TOPOLOGIES_TAGS="2_node_single_link_topo"
1084             ;;
1085         "1n_skx" | "1n_tx2")
1086             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1087             TOPOLOGIES_TAGS="2_node_single_link_topo"
1088             ;;
1089         "2n_skx")
1090             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1091             TOPOLOGIES_TAGS="2_node_*_link_topo"
1092             ;;
1093         "2n_zn2")
1094             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1095             TOPOLOGIES_TAGS="2_node_*_link_topo"
1096             ;;
1097         "3n_skx")
1098             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1099             TOPOLOGIES_TAGS="3_node_*_link_topo"
1100             ;;
1101         "2n_clx")
1102             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1103             TOPOLOGIES_TAGS="2_node_*_link_topo"
1104             ;;
1105         "2n_dnv")
1106             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1107             TOPOLOGIES_TAGS="2_node_single_link_topo"
1108             ;;
1109         "3n_dnv")
1110             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1111             TOPOLOGIES_TAGS="3_node_single_link_topo"
1112             ;;
1113         "3n_tsh")
1114             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1115             TOPOLOGIES_TAGS="3_node_single_link_topo"
1116             ;;
1117         "2n_tx2")
1118             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1119             TOPOLOGIES_TAGS="2_node_single_link_topo"
1120             ;;
1121         "2n_aws")
1122             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_aws*.yaml )
1123             TOPOLOGIES_TAGS="2_node_single_link_topo"
1124             ;;
1125         "3n_aws")
1126             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_aws*.yaml )
1127             TOPOLOGIES_TAGS="3_node_single_link_topo"
1128             ;;
1129         *)
1130             # No falling back to default, that should have been done
1131             # by the function which has set NODENESS and FLAVOR.
1132             die "Unknown specification: ${case_text}"
1133     esac
1134
1135     if [[ -z "${TOPOLOGIES-}" ]]; then
1136         die "No applicable topology found!"
1137     fi
1138 }
1139
1140
1141 function set_environment_variables () {
1142
1143     # Depending on testbed topology, overwrite defaults set in the
1144     # resources/libraries/python/Constants.py file
1145     #
1146     # Variables read:
1147     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1148     # Variables set:
1149     # See specific cases
1150
1151     set -exuo pipefail
1152
1153     case "${TEST_CODE}" in
1154         *"2n-aws"* | *"3n-aws"*)
1155             # T-Rex 2.88 workaround for ENA NICs
1156             export TREX_RX_DESCRIPTORS_COUNT=1024
1157             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1158             export TREX_CORE_COUNT=6
1159             # Settings to prevent duration stretching
1160             export PERF_TRIAL_STL_DELAY=0.1
1161             ;;
1162     esac
1163 }
1164
1165
1166 function untrap_and_unreserve_testbed () {
1167
1168     # Use this as a trap function to ensure testbed does not remain reserved.
1169     # Perhaps call directly before script exit, to free testbed for other jobs.
1170     # This function is smart enough to avoid multiple unreservations (so safe).
1171     # Topo cleanup is executed (call it best practice), ignoring failures.
1172     #
1173     # Hardcoded values:
1174     # - default message to die with if testbed might remain reserved.
1175     # Arguments:
1176     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1177     # Variables read (by inner function):
1178     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1179     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1180     # Variables written:
1181     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1182     # Trap unregistered:
1183     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1184     # Functions called:
1185     # - die - Print to stderr and exit.
1186     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1187
1188     set -xo pipefail
1189     set +eu  # We do not want to exit early in a "teardown" function.
1190     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1191     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1192     if [[ -z "${wt-}" ]]; then
1193         set -eu
1194         warn "Testbed looks unreserved already. Trap removal failed before?"
1195     else
1196         ansible_playbook "cleanup" || true
1197         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1198             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1199         }
1200         case "${TEST_CODE}" in
1201             *"2n-aws"* | *"3n-aws"*)
1202                 terraform_destroy || die "Failed to call terraform destroy."
1203                 ;;
1204             *)
1205                 ;;
1206         esac
1207         WORKING_TOPOLOGY=""
1208         set -eu
1209     fi
1210 }
1211
1212
1213 function warn () {
1214
1215     # Print the message to standard error.
1216     #
1217     # Arguments:
1218     # - ${@} - The text of the message.
1219
1220     set -exuo pipefail
1221
1222     echo "$@" >&2
1223 }